#ifndef STA_I2C_HPP
#define STA_I2C_HPP

#include <cstdint>
#include <sta/mutex.hpp>

namespace sta {
    class I2cDevice {
    protected:
        uint16_t address;
        Mutex* mutex;
        bool master;
        bool blocking;
    public:
        I2cDevice(uint16_t address_10bit, Mutex* mutex=nullptr, bool master=false, bool blocking=true);

        virtual bool transmit(uint8_t* data, uint16_t size) = 0;

        virtual bool receive(uint8_t* data, uint16_t size) = 0;

        virtual void acquire();

        virtual void release();
    };
}

#endif // STA_I2C_HPP
