#include <sta/spi/spi.hpp>


namespace sta
{
    SPI::SPI(const SPISettings & settings, Mutex * mutex /* = nullptr */)
        : settings_{settings}, mutex_{mutex}
    {}

    const SPISettings & SPI::settings() const
    {
        return settings_;
    }

    void SPI::acquire()
    {
        if (mutex_ != nullptr)
            mutex_->acquire();
    }

    void SPI::release()
    {
        if (mutex_ != nullptr)
            mutex_->release();
    }
} // namespace sta
